"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildTokenId = exports.isNativeCosmWasmDenom = exports.isNativeDenomXpla = exports.isNativeDenomInjective = void 0;
var utils_1 = require("ethers/lib/utils");
var terra_1 = require("../terra");
var utils_2 = require("../utils");
var isNativeDenomInjective = function (denom) { return denom === "inj"; };
exports.isNativeDenomInjective = isNativeDenomInjective;
var isNativeDenomXpla = function (denom) { return denom === "axpla"; };
exports.isNativeDenomXpla = isNativeDenomXpla;
function isNativeCosmWasmDenom(chainId, address) {
    return (((0, utils_2.isTerraChain)(chainId) && (0, terra_1.isNativeDenom)(address)) ||
        (chainId === utils_2.CHAIN_ID_INJECTIVE && (0, exports.isNativeDenomInjective)(address)) ||
        (chainId === utils_2.CHAIN_ID_XPLA && (0, exports.isNativeDenomXpla)(address)));
}
exports.isNativeCosmWasmDenom = isNativeCosmWasmDenom;
function buildTokenId(chain, address) {
    var chainId = (0, utils_2.coalesceCosmWasmChainId)(chain);
    return ((isNativeCosmWasmDenom(chainId, address) ? "01" : "00") +
        (0, utils_1.keccak256)(Buffer.from(address, "utf-8")).substring(4));
}
exports.buildTokenId = buildTokenId;
