/// <reference types="node" />
import { PublicKeyInitData } from "@solana/web3.js";
import { MockEmitter } from "./wormhole";
export declare class MockNftBridge extends MockEmitter {
    consistencyLevel: number;
    constructor(emitterAddress: string, chain: number, consistencyLevel: number);
    publishNftBridgeMessage(serialized: Buffer, nonce?: number, timestamp?: number, uptickSequence?: boolean): Buffer;
    publishTransferNft(tokenAddress: string, tokenChain: number, name: string, symbol: string, tokenId: bigint, uri: string, recipientChain: number, recipient: string, nonce?: number, timestamp?: number, uptickSequence?: boolean): Buffer;
}
export declare class MockEthereumNftBridge extends MockNftBridge {
    constructor(emitterAddress: string);
}
export declare class MockSolanaNftBridge extends MockNftBridge {
    constructor(emitterAddress: PublicKeyInitData);
}
