import { keccak256 } from "ethers/lib/utils";
import { isNativeDenom } from "../terra";
import { CHAIN_ID_INJECTIVE, CHAIN_ID_XPLA, coalesceCosmWasmChainId, isTerraChain, } from "../utils";
export var isNativeDenomInjective = function (denom) { return denom === "inj"; };
export var isNativeDenomXpla = function (denom) { return denom === "axpla"; };
export function isNativeCosmWasmDenom(chainId, address) {
    return ((isTerraChain(chainId) && isNativeDenom(address)) ||
        (chainId === CHAIN_ID_INJECTIVE && isNativeDenomInjective(address)) ||
        (chainId === CHAIN_ID_XPLA && isNativeDenomXpla(address)));
}
export function buildTokenId(chain, address) {
    var chainId = coalesceCosmWasmChainId(chain);
    return ((isNativeCosmWasmDenom(chainId, address) ? "01" : "00") +
        keccak256(Buffer.from(address, "utf-8")).substring(4));
}
