/// <reference types="node" />
import { PublicKeyInitData } from "@solana/web3.js";
import { ethers } from "ethers";
import { ChainId, ChainName } from "../utils";
/**
 * Returns a foreign asset address on Ethereum for a provided native chain and asset address, AddressZero if it does not exist
 * @param nftBridgeAddress
 * @param provider
 * @param originChain
 * @param originAsset zero pad to 32 bytes
 * @returns
 */
export declare function getForeignAssetEth(nftBridgeAddress: string, provider: ethers.Signer | ethers.providers.Provider, originChain: ChainId | ChainName, originAsset: Uint8Array): Promise<string | null>;
/**
 * Returns a foreign asset address on Solana for a provided native chain and asset address
 * @param nftBridgeAddress
 * @param originChain
 * @param originAsset zero pad to 32 bytes
 * @returns
 */
export declare function getForeignAssetSolana(nftBridgeAddress: PublicKeyInitData, originChain: ChainId | ChainName, originAsset: string | Uint8Array | Buffer, tokenId: Uint8Array | Buffer | bigint): Promise<string>;
export declare const getForeignAssetSol: typeof getForeignAssetSolana;
