import { Commitment, Connection, PublicKeyInitData, Transaction } from "@solana/web3.js";
import { ethers, Overrides } from "ethers";
import { submitVAAOnInjective } from "./redeem";
import { SignedVaa } from "../vaa";
export declare function createWrappedOnEth(tokenBridgeAddress: string, signer: ethers.Signer, signedVAA: Uint8Array, overrides?: Overrides & {
    from?: string | Promise<string>;
}): Promise<ethers.ContractReceipt>;
export declare const createWrappedOnInjective: typeof submitVAAOnInjective;
export declare function createWrappedOnSolana(connection: Connection, bridgeAddress: PublicKeyInitData, tokenBridgeAddress: PublicKeyInitData, payerAddress: PublicKeyInitData, signedVaa: SignedVaa, commitment?: Commitment): Promise<Transaction>;
