var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import nearAPI from "near-api-js";
import BN from "bn.js";
export function logNearGas(result, comment) {
    var _a = result.receipts_outcome.reduce(function (acc, receipt) {
        acc.totalGasBurned += receipt.outcome.gas_burnt;
        acc.totalTokensBurned += nearAPI.utils.format.formatNearAmount(receipt.outcome.tokens_burnt);
        return acc;
    }, {
        totalGasBurned: result.transaction_outcome.outcome.gas_burnt,
        totalTokensBurned: nearAPI.utils.format.formatNearAmount(result.transaction_outcome.outcome.tokens_burnt),
    }), totalGasBurned = _a.totalGasBurned, totalTokensBurned = _a.totalTokensBurned;
    console.log(comment, "totalGasBurned", totalGasBurned, "totalTokensBurned", totalTokensBurned);
}
export function hashAccount(provider, tokenBridge, account) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, isRegistered, accountHash;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, callFunctionNear(provider, tokenBridge, "hash_account", { account: account })];
                case 1:
                    _a = __read.apply(void 0, [_b.sent(), 2]), isRegistered = _a[0], accountHash = _a[1];
                    return [2 /*return*/, {
                            isRegistered: isRegistered,
                            accountHash: accountHash,
                        }];
            }
        });
    });
}
export function hashLookup(provider, tokenBridge, hash) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, found, value;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, callFunctionNear(provider, tokenBridge, "hash_lookup", {
                        hash: hash,
                    })];
                case 1:
                    _a = __read.apply(void 0, [_b.sent(), 2]), found = _a[0], value = _a[1];
                    return [2 /*return*/, {
                            found: found,
                            value: value,
                        }];
            }
        });
    });
}
export function registerAccount(account, tokenBridge) {
    return {
        contractId: tokenBridge,
        methodName: "register_account",
        args: { account: account },
        gas: new BN("100000000000000"),
        attachedDeposit: new BN("2000000000000000000000"),
    };
}
export function callFunctionNear(provider, accountId, methodName, args) {
    return __awaiter(this, void 0, void 0, function () {
        var response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, provider.query({
                        request_type: "call_function",
                        account_id: accountId,
                        method_name: methodName,
                        args_base64: args
                            ? Buffer.from(JSON.stringify(args)).toString("base64")
                            : "",
                        finality: "final",
                    })];
                case 1:
                    response = _a.sent();
                    return [2 /*return*/, JSON.parse(Buffer.from(response.result).toString())];
            }
        });
    });
}
